from osv import fields, osv
import string
import time
import base64
from tools.translate import _
import os
import StringIO
import csv
    
class wizard_module_select(osv.osv_memory):
    _name='wizard.module.select'
    
    STATE_SELECTION = [
        ('draft', 'Draft'),
        ('done', 'Done'),
    ]
    _columns={
              'module_ids':fields.many2many('ir.module.module','module_list_rel','module_list_id','mosule_id','Modules',required=True),
              'csv_file':fields.binary('CSV File',readonly=True),
              'state': fields.selection(STATE_SELECTION, 'State', readonly=True,),
              'show_file':fields.boolean("Show Field")
              }
    
    _defaults = {
        'state': 'draft',
        'show_file': False,
    } 
    def generate_csv(self,cr,uid,ids,context={}):
        
        form=self.browse(cr,uid,ids)[0]
        
        FirstRow=['Module','Object','Field','Field Type','Field Label','Tool Tip']
        row = []
        module_list=self.pool.module_object_list
#        file_name = 'module.csv'
#        csv_data = csv.writer(open(file_name, "wb"), delimiter=',', quotechar='"')
#        csv_data.writerow(FirstRow)
        csv_data=[','.join(FirstRow)]
        print "All modules in pool", module_list.keys()
        if form.module_ids:
            for module in form.module_ids:
                
                mod_obj_list=module_list.get(module.name,[])
                
                for mod_obj in mod_obj_list:
                    
                    for column in mod_obj._columns.keys():
                        #field_nam<--column
                        field=mod_obj._columns.get(column,False)
                        field_string=field.string
                        field_type=field._type
                        field_help='"%s"'%field.help
#                        row.append([module.name,mod_obj._name,column,field_type,field_string,field_help])
                        row=[module.name,mod_obj._name,column,field_type,field_string,field_help]
                        csv_data.append(','.join(row))
                    if not mod_obj._columns.keys():
#                        row.append([module.name,mod_obj._name,"No Fields"])
                        row=[module.name,mod_obj._name,"No Fields"]
                        csv_data.append(','.join(row))
                if not mod_obj_list:
#                    row.append([module.name,"No Objects"])
                    row=[module.name,"No Objects"]
                    csv_data.append(','.join(row))
        else:
            assert False,"No modules selected"
        csv_data='\n'.join(csv_data)
        
#        for line in row:
#            csv_data.writerow(line)
        form.write({"show_file":True,"csv_file":base64.encodestring(csv_data)})
        
        return {
                'nodestroy':True
                
                }
        
    def select_module(self, cr, uid, ids, context=None):
        return {'nodestroy':True}
    
wizard_module_select()
